# -*- coding:utf-8-unix -*-
#
# $Id: $
#
# Copyright (c) 2000-2003 Turbolinux, inc. 
# This file and all modifications and/or additions are under 
# the same license as package itself.

%define nam		ghostscript
%define ver		7.06
%define rel		24
%define srl		2005121101

%define hpijs_ver	1.5
%define opvp_ver	1.0.0
%define opvp_srcver	1.05
%define eplaser_ver	3.2.0
%define with_gimpprint  1

Summary:	A PostScript(TM) interpreter and renderer.
Summary(ja_JP.utf8):        GhostScript - PostScriptインタプリタ、レンダラ
Name:		%{nam}
Version:	%{ver}
Release:	%{rel}
Serial:		%{srl}
Group:		Applications/Publishing
License:	GPL
URL:		http://www.ghostscript.com/
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Source0:	ftp://mirror.cs.wisc.edu/pub/mirrors/ghost/gnu/gs706/ghostscript-%{version}.tar.bz2
Source1:	http://prdownloads.sf.net/hpinkjet/hpijs-%{hpijs_ver}.tar.gz
# OpenPrinting vector printer driver glue code for ghostscript-7.06
Source2:	gdevopvp-%{opvp_srcver}.tar.bz2

# EPSON eplaser drivers
Source3:	http://www.epkowa.co.jp/linux/dl_laser.html/eplaser-%{eplaser_ver}.tgz
Patch300:	ghostscript-7.06-eplaser-%{eplaser_ver}.patch
Provides:	eplaser = %{eplaser_ver}

#NoSource:	0
#NoSource:	1
#NoSource:	2
#NoSource:	3

# Patch against ESP ghostscript-7.05-6
Patch0:		ghostscript-7.06-espgs7056.patch.gz
#NoPatch:	0

# This patch is on top of espgs7056.patch
Patch1:		ghostscript-7.06-hpijs.patch

# Patches from Redhat
# Patch to make ps2espi better/work
Patch2:		ghostscript-7.05-ps2epsi.patch
# Fix the gs path in lprsetup.sh
Patch3:		ghostscript-6.51-gs_path.patch
# Stupid ia64 jmp_buf alignment patch
Patch4:		ghostscript-6.51-ia64_jmp_buf.patch
# Fix some shell scripts
Patch5:		ghostscript-7.05-scripts.patch
# Fix compilation with newer binutils
Patch6:		ghostscript-7.05-fPIC.patch
# Fix XLIBDIR
Patch7:		ghostscript-7.05-x11.patch
Patch8:		ghostscript-7.05-oob-66421.patch
# for backward compat
Patch11:	ghostscript-7.06-kanji.patch
Patch12:	ghostscript-7.06-gcc34.patch

Patch20: http://tagoh.jp/junk/ghostscript-7.07-bigposttable.patch
Patch21: http://tagoh.jp/junk/ghostscript-7.07-gsublookuptable.patch
Patch22: http://tagoh.jp/junk/ghostscript-7.07-coverage-glyphcount.patch
Patch23: http://www.aihara.co.jp/~taiji/gyve/tmp/fix_rename_font_gs_cidfn.ps.patch
Patch24: http://www.aihara.co.jp/~taiji/gyve/tmp/fix_cidfontname_Encoding_CIDToGIDMap_DW_W.patch
Patch25: http://www.aihara.co.jp/~taiji/gyve/tmp/ghostscript-7.07-bigcmaptable.patch
Patch26: http://www.aihara.co.jp/~taiji/gyve/tmp/ghostscript-7.07-noglyph-gid0.patch
Patch27: http://www.aihara.co.jp/~taiji/gyve/tmp/fix_cidfonttype2_Adobe-CNS1-4.patch
Patch28: http://www.aihara.co.jp/~taiji/gyve/tmp/ghostscript-7.07-seekCFFtable.patch
Patch29: http://www.aihara.co.jp/~taiji/gyve/tmp/ghostscript-7.07-readFDSelect.patch
Patch30: http://www.aihara.co.jp/~taiji/gyve/tmp/ghostscript-7.07-write_GSubrs.patch
Patch31: http://www.aihara.co.jp/~taiji/gyve/tmp/ghostscript-7.07-nosyoffsetcheck.patch
Patch32: http://www.aihara.co.jp/~taiji/gyve/tmp/fix_cidfonttype2_Adobe-Japan1-6.patch

# hpijs enhancement patch from:
Patch100:	http://www.linuxprinting.org/download/printing/hpijs/hpijs-1.4.1-rss.1.patch
Patch101:	hpijs-1.5-x86_64.patch
Patch102:	hpijs-1.5-gcc34.patch

# OpenPrinting vector printer driver glue code for ghostscript-7.06
Patch200: 	ghostscript-7.06-gdevopvp-%{opvp_ver}.patch
Provides:	opvp = %{opvp_ver}


Requires:	zlib, libpng, glib, libjpeg, libtiff
Requires:	urw-fonts >= 1.1, ghostscript-fonts
Requires:	cups-libs >= 1.1.13
Requires:	XFree86-libs

BuildRequires:	autoconf >= 2.53
BuildRequires:	zlib-devel, libpng-devel, unzip, gtk+-devel, openssl-devel
BuildRequires:	glib-devel, XFree86-devel, libtiff-devel, libjpeg-devel
BuildRequires:	cups-devel >= 1.1.13

%if %{with_gimpprint}
Requires:	gimp-print >= 4.2.5
BuildRequires:  gimp-print-devel
%endif

# Omni requires libxml
BuildRequires:	libxml-devel

Provides:	hpijs = %{hpijs_ver}
Obsoletes:	hpijs


%description
Ghostscript is a set of software that provides a PostScript(TM)
interpreter, a set of C procedures (the Ghostscript library, which
implements the graphics capabilities in the PostScript language) and an
interpreter for Portable Document Format (PDF) files.  Ghostscript
translates PostScript code into many common, bitmapped formats, like those
understood by your printer or screen.  Ghostscript is normally used to
display PostScript files and to print PostScript files to non-PostScript
printers.

If you need to display PostScript files or print them to non-PostScript
printers, you should install ghostscript.  If you install ghostscript, you
also need to install the ghostscript-fonts package.

%description -l ja_JP.utf8
このパッケージにはPostScript/PDFインタプリタであるGhostScriptが含まれています
GhostScriptはPostScriptフォーマットやPDFフォーマット、BMPやPNG等の画像フォーマット
を様々なプリンタ用コードに変換する事ができます。
非PostScriptプリンタに印刷を行うには必須のアプリケーションです。

%package devel
Summary:	Files for developing applications that use ghostscript.
Summary(ja_JP.utf8):        GhostScript - 開発ライブラリ
Requires:	%{name} = %{version}
Group:		Development/Libraries

%description devel
The header files for developing applications that use ghostscript.

%description devel -l ja_JP.utf8
このパッケージにはGhostScriptを使用したアプリケーションを開発するために必要なファイルが含まれています。

%package cups
Summary:	Ghostscript Support for CUPS
Summary(ja_JP.utf8):        GhostScript - CUPSドライバ
Group:		Applications/Publishing
Requires:	%{name} = %{version}
Requires:	cups >= 1.1.13

%description cups
Ghostscript support for the Common UNIX Printing System
("CUPS"). This package is required to support non-PostScript
printers with CUPS.

%description cups -l ja_JP.utf8
このパッケージには印刷システムCUPSからGhostScriptを呼び出すために必要なファイルが含まれています。

%{?_build_debug:%{debug_package}}

#---------- BUILD SECTION ---------------------------------------------------

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1 -b .espgs
%patch1 -p1 -b .hpijs
%patch2 -p1 -b .ps2epsi
%patch3 -p1 -b .gs_path
%patch4 -p1 -b .ia64_jmp_buf
%patch5 -p1 -b .scripts
%patch6 -p1 -b .fPIC
%patch7 -p1 -b .x11
%patch8 -p1 -b .oob
%patch11 -p1 -b .kanji
%patch12 -p1 -b .gcc34

%patch20 -p1 -b .bigposttable
%patch21 -p1 -b .gsublookuptable
%patch22 -p1 -b .coverage-glyphcount
%patch23 -p0 -b .fix_rename_font_gs_cidfn
%patch24 -p0 -b .fix_cidfontname_Encoding_CIDToGIDMap_DW_W
%patch25 -p0 -b .bigcmaptable
%patch26 -p0 -b .noglyph-gid0
%patch27 -p0 -b .fix_cidfonttype2_Adobe-CNS1-4
%patch28 -p0 -b .seekCFFtable
%patch29 -p0 -b .readFDSelect
%patch30 -p0 -b .write_GSubrs
%patch31 -p0 -b .nosyoffsetcheck
%patch32 -p0 -b .fix_cidfonttype2_Adobe-Japan1-6

# setup OpenPrinting vector printer driver glue code for ghostscript
%setup -q -T -D -a2 -c -n %{name}-%{version}/gdevopvp-%{opvp_srcver}/
cp src/*.[ch] ../src/
cp src/*.def ../src/
cd ..
%patch200 -p1 -b .opvp

# setup EPSON KOWA ghostscript driver
%setup -q -T -D -a3
cat eplaser-%{eplaser_ver}/gdevescv.mak >> src/contrib.mak
cp eplaser-%{eplaser_ver}/*.[ch] ./src/
%patch300 -p1 -b .eplaser

# setup hpijs
%setup -q -T -D -a1
cd hpijs-%{hpijs_ver}
%patch100 -p1 -b .rss
%patch101 -p1 -b .x86_64
%patch102 -p1 -b .gcc34
cd ..

cd ijs
autoconf
cd ..

# workaround patch to avoid resource error.
# See more information
# http://www.ghostscript.com/pipermail/gs-devel/2002-July/001858.html
# http://www.ghostscript.com/pipermail/gs-devel/2002-July/001889.html
#%patch11 -p1 -b .acro5

autoconf


%build
# Build ijs
cd ijs
%configure
make
cd ..

# Build ghostscript
%configure \
  --with-fontpath=%{_datadir}/fonts/:%{_prefix}/X11R6/lib/X11/fonts
make

# Build hpijs
cd hpijs-%{hpijs_ver}
%configure
make
cd ..

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

# make all necessary direstories, ghostscript will not create them.
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{%{_mandir},%{_bindir},%{_datadir},%{_docdir}}
mkdir -p $RPM_BUILD_ROOT/{%{_libdir},%{_includedir}/ijs}

# install_prefix is for cups installation, see pstoraster/cups.mak
make install \
        prefix=$RPM_BUILD_ROOT%{_prefix} \
        mandir=$RPM_BUILD_ROOT%{_mandir} \
        datadir=$RPM_BUILD_ROOT%{_datadir} \
        bindir=$RPM_BUILD_ROOT%{_bindir} \
        libdir=$RPM_BUILD_ROOT%{_libdir} \
        docdir=$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version} \
	install_prefix=$RPM_BUILD_ROOT

cd ijs
make install \
        prefix=$RPM_BUILD_ROOT%{_prefix} \
        mandir=$RPM_BUILD_ROOT%{_mandir} \
        datadir=$RPM_BUILD_ROOT%{_datadir} \
        bindir=$RPM_BUILD_ROOT%{_bindir} \
        libdir=$RPM_BUILD_ROOT%{_libdir} \
	includedir=$RPM_BUILD_ROOT%{_includedir}
cd ..

cd hpijs-%{hpijs_ver}
make install DESTDIR=$RPM_BUILD_ROOT
cd ..

ln -sf gs.1.gz $RPM_BUILD_ROOT/%{_mandir}/man1/ghostscript.1.gz
ln -sf gs $RPM_BUILD_ROOT/usr/bin/ghostscript

# Don't ship ijs_client_example.
rm -f $RPM_BUILD_ROOT%{_bindir}/ijs_client_example

# Don't ship sysvlp.sh.
rm -f $RPM_BUILD_ROOT/usr/bin/sysvlp.sh

# Don't ship foomatic-rip
rm -f $RPM_BUILD_ROOT/usr/bin/foomatic-rip

mkdir -p $RPM_BUILD_ROOT/%{_datadir}/ghostscript/Resource
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/ghostscript/Resource/CIDFont
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/ghostscript/Resource/Font

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)
%doc doc/* hpijs-%{hpijs_ver}/gs_hpijs.png hpijs-%{hpijs_ver}/hpijs_readme.html
%dir %{_datadir}/ghostscript
%dir %{_datadir}/ghostscript/%{version}
%{_datadir}/ghostscript/%{version}/lib
%{_datadir}/ghostscript/%{version}/examples
%dir %{_datadir}/ghostscript/Resource
%dir %{_datadir}/ghostscript/Resource/CIDFont
%dir %{_datadir}/ghostscript/Resource/Font
%{_bindir}/*
%{_libdir}/libijs.so*
%{_mandir}/man?/*

%files cups
%defattr(-,root,root)
%{_sysconfdir}/cups/pstoraster.convs
%{_libdir}/cups/filter/pstoraster

%files devel
%defattr(-, root, root)
%{_includedir}/ijs
%{_bindir}/ijs-config
%{_libdir}/libijs.a

#--------------------------------------------------

%changelog
* Thu Jan 19 2006 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> - 7.06-24
- minor update opvp-v1.05

* Sun Dec 11 2005 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> - 7.06-23
- re-updated opvp to 1.05

* Thu Dec  1 2005 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> - 7.06-22
- fixed corrupted messages
- use stable version opvp-1.04

* Wed Nov 30 2005 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> - 7.06-21
- applied patches for handle some ttf/otf fonts

* Wed Nov 16 2005 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> - 7.06-20
- updated opvp to 1.05

* Mon Sep  5 2005 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> - 7.06-19
- updated eplaser driver to 3.2.0

* Fri Jul 29 2005 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> - 7.06-18
- added kanji patch

* Sat Jun 11 2005 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> - 7.06-17
- updated opvp to 1.04

* Wed Mar 23 2005 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- updated opvp to 1.03

* Fri Nov 26 2004 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- updated opvp to 1.02

* Tue Nov  9 2004 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- added with_gimpprint build option
- added x86_64 patch
- cleanup patches

* Mon Oct 25 2004 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- updated opvp to 1.01

* Mon Aug 30 2004 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- applied eplaser patch again
- added eplaser gcc333 patch

* Mon Aug 23 2004 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- upto hpijs to 1.5

* Fri Jul 23 2004 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- updated opvp patch to 1.00-rel-0.8

* Mon May 10 2004 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added workaround patch to avoid AR5 PS resource error.
- See more information: http://www.ghostscript.com/pipermail/gs-devel/2002-July/001889.html

* Fri Apr  9 2004 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated opvp patch to 1.00-rel-0.7

* Wed Mar 31 2004 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated opvp patch to 1.00-rel-0.6

* Mon Mar  8 2004 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added opvp(OpenPrinting Vector driver) patch

* Tue Apr 15 2003 James Su <suzhe@turbolinux.com.cn>
- applied hpijs-1.3-rss.1.patch
- added missing Requires and BuildRequires

* Mon Apr 14 2003 James Su <suzhe@turbolinux.com.cn>
- upto v7.0.6.
- merged changes from ESP ghostscript 7.05.6.
- merged some patchs from Redhat.
- remove CMaps out of this package, they are provided by CMap package.

* Sat Mar 22 2003 Go Taniguchi <go@turbolinux.co.jp>
- support x86_64

* Thu Jun  6 2002 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- copy gomni.c,defs.h from Omni-0.7.0
- added cups driver from CUPS-1.1.15

* Fri May 10 2002 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- added some upp files
- updated eplaser to 3.0.2
- added pcl3 driver
- updated gdevnpdl to 1.6.3

* Tue Apr 30 2002 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- added bjc250 driver
- added gdi driver

* Fri Apr 26 2002 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- modified spec radically for correspond to support foomatic-filter

* Tue Jan 29 2002 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp>
- added gimp-print
- added hp-ijs driver

* Sat Dec 15 2001 James Su <suzhe@turbolinux.com.cn>
- Applied gs6.51-cjk-M2-R3-gs_ttf.patch, which fixed some bugs in gs_ttf.ps

* Tue Dec 11 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated gs-cjk patch to M2-R3

* Tue Oct  9 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added eplaser.patch for support EPSON LaserPrinter from EPSON Kowa.
  [LP-8500C,LP-8300C,LP-8200C,LP-3000C,LP-9400,LP-9400R,LP-8700,LP-8700R,LP-8600FX and more]
  
* Fri Oct  5 2001 James Su <suzhe@turbolinux.com.cn>
- removed default value of TTFontDir in alias-cid.sh.
  created symlinks alias-ac13.sh, alias-ag14.sh, alias-aj14.sh,
  alias-aj20.sh, alias-ak12.sh for backward compatibility.

* Fri Oct  5 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated gs-cjk to M2-R2

* Tue Aug 28 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- applied omni.patch

* Wed Jul 4 2001 James Su <suzhe@turbolinux.com.cn>
- Upgraded gs-cjk to M2-R1.

* Sat Jun 30 2001 James Su <suzhe@turbolinux.com.cn>
- added gdevlips driver ( lips2p lips3 lips4 lips4v bjc880j escpage 
  lp2000 npdl rpdl ), use rpdl to replace nx100r nx100v

* Thu Jun 28 2001 James Su <suzhe@turbolinux.com.cn>
- Upgrade to 6.51
- Add GS-CJK support.
- initial release for TLW7

* Mon Mar 20 2000 Russell Lang <gsview@ghostgum.com.au>
- ghostscript 6.50 release
  Built under RedHat 6.2.
- ghostscript 6.01 release
  Added RPM_OPT_FLAGS
  Added more Ghostscript devices.

* Sun Feb 13 2000 Russell Lang <gsview@ghostgum.com.au>
- ghostscript 6.0 release
  Built under RedHat 5.1.
  Objective is to make this RPM as portable as possible.
  Minimal changes to Makefile.
  This is an Aladdin release, not GNU.
